#!/usr/bin/env python

################################################################################ 
#
#
#
#http://water.weather.gov/ahps2/hydrograph_to_xml.php?gage=rvbc1&output=tabular
#
# 
#
#Stations listing for the Delta:
# 
#
#Rio Vista:  rvbc1
#
#Antioch:  atic1
#
#Mallard Island:  mlic1
#
#Venice Island:  vncc1
#
#I Street Bridge:  sacc1
#
#Mossdale Bridge:  mosc1
#
#Vernalis:  vnsc1
#
################################################################################

import time
from datetime import date
import nmf
#import functions.txt
import urllib2
from BeautifulSoup import BeautifulStoneSoup
from numpy import *

stids =['rvbc1','atic1','mlic1','vncc1','sacc1','mosc1','vnsc1']

# calculate number of observations/forcasts lower bound
lbto = 1000
lbfo = 1000
lbtf = 1000
lbff = 1000

#date stuff
dsecs = 24*60*60
yday = time.time() - dsecs
yesterday = date.fromtimestamp(yday)
vard = str(yesterday.year) + '-' + str(yesterday.month) + '-' + str(yesterday.day)


tidesobserved={}
flowobserved={}
tidesforecast={}
flowforecast={}
datesobserved=None
datesforecast=None

for t in stids:
	#Open the URL
	url2open = 'http://water.weather.gov/ahps2/hydrograph_to_xml.php?gage=' + t + '&output=xml'
	print 'Opening : ' + url2open
	tideData=urllib2.urlopen(url2open)
	
	
	#print tideData
	
	# Extract the volume field from every line

	#geocodeXML=BeautifulStoneSoup(geocodeData)
	#if geocodeXML.kml.response.status.code.string=='200':
	#note casing of below line! addressdetails['Accuracy'] will raise an exception!
	#geocodeResults['accuracy']=geocodeXML.kml.response.placemark.addressdetails['accuracy']

	tideXML=BeautifulStoneSoup(tideData)
	
	observed=tideXML.site('observed')[1]('datum')
	
	forecast=tideXML.site.forecast('datum')

	#print observed
	#print '##############################################'
	#print forecast

	print "Number of observations in data : " + str(len(observed))
	
	#observed
	hightide = 0
	lowtide = 1000
	httime = None
	lttime = None
	flowht = None
	flowlt = None
	for datum in observed:
		if datum.valid.string.find(vard) > -1:
			if float(datum.primary.string) > hightide:
				hightide = float(datum.primary.string)
				httime	= datum.valid.string
				flowht = datum.secondary.string

			if float(datum.primary.string) < lowtide:
				lowtide = float(datum.primary.string)
				lttime	= datum.valid.string
				flowlt	= datum.secondary.string
	
	
	tidesobserved[t]=[hightide, lowtide, httime, lttime, flowht, flowlt]
	#flowobserved[t]=[float(datum.secondary.string) for datum in observed if datum.valid.string.find(vard) > -1]
	
	#forecasts
	tidesforecast[t]=[float(datum.primary.string) for datum in forecast]
	flowforecast[t]=[float(datum.secondary.string) for datum in forecast]

	
	#if not datesobserved:
	#	datesobserved=[datum.valid.string for datum in observed if datum.valid.string.find(vard) > -1]
	
	#if not datesforecast:
	#	datesforecast=[datum.valid.string for datum in forecast]
		
	#if len(tidesobserved[t])<lbto: lbto=len(tidesobserved[t])
	#if len(flowobserved[t])<lbfo: lbfo=len(flowobserved[t])
	#if len(tidesforecast[t])<lbtf: lbtf=len(tidesforecast[t])
	#if len(flowforecast[t])<lbff: lbff=len(flowforecast[t])
	#print lbto , lbfo, lbtf, lbff
 

#print tidesobserved['vnsc1']

for t in stids:
	print t, tidesobserved[t]