#!/usr/bin/env python

################################################################################ 
#
#
#
#http://water.weather.gov/ahps2/hydrograph_to_xml.php?gage=rvbc1&output=tabular
#
# 
#
#Stations listing for the Delta:
# 
#
#Rio Vista:  rvbc1
#
#Antioch:  atic1
#
#Mallard Island:  mlic1
#
#Venice Island:  vncc1
#
#I Street Bridge:  sacc1
#
#Mossdale Bridge:  mosc1
#
#Vernalis:  vnsc1
#
################################################################################

import time
from datetime import date
import nmf
#import functions.txt
import urllib2
from BeautifulSoup import BeautifulStoneSoup
from numpy import *

stids =['rvbc1','atic1','mlic1','vncc1','sacc1','mosc1','vnsc1']

# calculate number of observations/forcasts lower bound
lbto = 1000
lbfo = 1000
lbtf = 1000
lbff = 1000

#date stuff
dsecs = 24*60*60
yday = time.time() - dsecs
yesterday = date.fromtimestamp(yday)
vard = str(yesterday.year) + '-' + str(yesterday.month) + '-' + str(yesterday.day)


tidesobserved={}
flowobserved={}
tidesforecast={}
flowforecast={}
datesobserved=None
datesforecast=None

for t in stids:
	#Open the URL
	url2open = 'http://water.weather.gov/ahps2/hydrograph_to_xml.php?gage=' + t + '&output=xml'
	print 'Opening : ' + url2open
	tideData=urllib2.urlopen(url2open)
	
	
	#print tideData
	
	# Extract the volume field from every line

	#geocodeXML=BeautifulStoneSoup(geocodeData)
	#if geocodeXML.kml.response.status.code.string=='200':
	#note casing of below line! addressdetails['Accuracy'] will raise an exception!
	#geocodeResults['accuracy']=geocodeXML.kml.response.placemark.addressdetails['accuracy']

	tideXML=BeautifulStoneSoup(tideData)
	
	observed=tideXML.site('observed')[1]('datum')
	
	forecast=tideXML.site.forecast('datum')

	#print observed
	#print '##############################################'
	#print forecast

	print "Number of observations in data : " + str(len(observed))
	
	#observed
	#tidesobserved[t]=[float(datum.primary.string) for datum in observed if datum.valid.string.split(':')[1] == '00']
	#flowobserved[t]=[float(datum.secondary.string) for datum in observed if datum.valid.string.split(':')[1] == '00']
	tidesobserved[t]=[float(datum.primary.string) for datum in observed if datum.valid.string.find(vard) > -1]
	flowobserved[t]=[float(datum.secondary.string) for datum in observed if datum.valid.string.find(vard) > -1]
	
	#forecasts
	tidesforecast[t]=[float(datum.primary.string) for datum in forecast]
	flowforecast[t]=[float(datum.secondary.string) for datum in forecast]

	
	if not datesobserved:
		datesobserved=[datum.valid.string for datum in observed if datum.valid.string.find(vard) > -1]
	
	if not datesforecast:
		datesforecast=[datum.valid.string for datum in forecast]
		
	if len(tidesobserved[t])<lbto: lbto=len(tidesobserved[t])
	if len(flowobserved[t])<lbfo: lbfo=len(flowobserved[t])
	if len(tidesforecast[t])<lbtf: lbtf=len(tidesforecast[t])
	if len(flowforecast[t])<lbff: lbff=len(flowforecast[t])
	
	print lbto , lbfo, lbtf, lbff
 



#print tidesobserved['vnsc1']

print len(tidesobserved['vnsc1'])

l1=[[tidesobserved[stids[i]][j] for i in range(len(stids))] for j in range(lbto)]

w,h=nmf.factorize(matrix(l1),pc=1)

#print h
#print w

#Loop over all the features
for i in range(shape(h)[0]):
	print "Feature %d" %i
	
	#Get the top tides for this feature
	ol=[(h[i,j],stids[j]) for j in range(shape(h)[1])]
	ol.sort()
	ol.reverse()
	for j in range(7):
		print ol[j]
	print
	
	
	#Show top dates for this feature
	porder=[(w[d,i],d) for d in range(shape(w)[0])]
	porder.sort()
	porder.reverse()
	print [(p[0],datesobserved[p[1]]) for p in porder[0:3]]
	print